set clabel '%8.3g'
set grid
set style data linespoints
set xrange [0:1]
set yrange [0:1]
set xlabel "RD"
set ylabel "recall"  offset 2
set title "Adult dataset, minsupp=48"
set key inside top left
set xtics .1

cond(x,y,z) = (x == y) ? (z) : 1/0

set terminal postscript enhanced eps color "Helvetica" 25
set output "frechet_adult_dist_recall.eps"

plot "frechet_adult_discretized_48.aggr" using (cond($1,1,$2)):($3/$5) title "ni=1" with linespoint lw 6 linecolor rgb 'red',\
'' using (cond($1,5,$2)):($3/$5) title "ni=5" with linespoint lw 6 linecolor rgb 'blue',\
'' using (cond($1,30,$2)):($3/$5) title "ni=30" with linespoint lw 6 linecolor rgb '#3CB371'