package dd.papers.sac2012.topK;

import java.util.TreeSet;

import rst.util.Cronos;
import dd.util.ContingencyTable;
import dd.util.DDTable;

public class TopK {

	public static void main(String[] args) throws Exception 
	{
		credit("papers/sac2012/topk", "credit", "personal_status=female_div_or_dep_or_mar,age=gt_52d6,foreign_worker=yes", "class=bad", 20, false);
	}

	public static void credit(String wdir, String dataset, String PD, String dec, int MINSUPP, boolean append) throws Exception 
	{
		final int TOPTABLES = 1000;

		Cronos c = new Cronos();
		c.start();
		DDTable tb = new DDTable();
		tb.setWorkingDir(wdir + "/" + dataset);
		tb.loadFromArff(dataset);
		tb.setDiscMetaData(PD, dec, MINSUPP);
		tb.closedItemset = true;
		tb.extractItemsets(); // only needed if not already extracted
		tb.initScan();
		int nt = 0;
		TreeSet<ContingencyTable> topRD = new TreeSet<ContingencyTable>( new ContingencyTable.CompMeasure( new ContingencyTable.CompRD() ) );
		TreeSet<ContingencyTable> topRR = new TreeSet<ContingencyTable>( new ContingencyTable.CompMeasure( new ContingencyTable.CompRR() ) );
		ContingencyTable ct;
		// find top tables using direct discrimination discovery
//		int nt2 = 0;
		while( (ct = tb.nextCT()) != null) {
			if( ct.a < MINSUPP || ct.c == 0 ) 
				continue;
//			if( ct.specs.pdItemset.size() + ct.frset.size() == 2) {
//				++nt2;
//				System.out.println( ct.specs.pdItemset + " " + ct.frset + " " + ct);
//			}
			// check if p1 and p2 are defined
			nt++;
			topRD.add(ct);
			topRR.add(ct);
			// keep only best tables
			if( nt > TOPTABLES ) {
				topRD.remove(topRD.first());
				topRR.remove(topRR.first());
			}
		}
		tb.endScan();
//		System.out.println("no.: " + nt2);
		System.out.println("no. contingency tables: " + nt);
		
		int rdRRint = 0;
		int rdRRonlyrd = 0;
		int rdRRonlyRR = 0;
		double topMissed = Double.MIN_VALUE;
		double bottomIncluded = Double.MAX_VALUE;
		for(ContingencyTable table : topRD) {
			if( topRR.contains(table) )
				rdRRint++;
			else {
				rdRRonlyrd++;
				double rr = table.rr();
				if( bottomIncluded > rr )
					bottomIncluded = rr;
			}
		}
		for(ContingencyTable table : topRR) {
			if( !topRD.contains(table) ) {
				rdRRonlyRR++;
				double rr = table.rr();
				if( topMissed < rr )
					topMissed = rr;
			}
		}
//		System.out.println(topRD.last() + " " + topRD.last().frset);
		System.out.println("RD\tRR\t" + topRD.last().rd() + "\t" + topRD.first().rd() + "\t"
				 + topRR.last().rr() + "\t" + topRR.first().rr() + "\t"
				 + "\t" + topMissed + "\t" + bottomIncluded
				 + "\t" + rdRRint + "\t" + rdRRonlyrd + "\t" + rdRRonlyRR
				);
		

		c.stop();
		System.out.println("Elapsed time (s): " + c.elapsed());
	}
}
